package eu.eudat.dao.entities;

import eu.eudat.dao.databaselayer.service.DatabaseService;
import eu.eudat.entities.ExternalDataset;
import eu.eudat.entities.Project;
import eu.eudat.models.criteria.ExternalDatasetCriteria;
import eu.eudat.queryable.QueryableList;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.UUID;

/**
 * Created by ikalyvas on 1/17/2018.
 */
@Component("externalDatasetDao")
public class ExternalDatasetDaoImpl implements ExternalDatasetDao {

    @Autowired
    DatabaseService<ExternalDataset> databaseService;

    @Override
    public QueryableList<ExternalDataset> getWithCriteria(ExternalDatasetCriteria criteria) {
        QueryableList<ExternalDataset> query = this.databaseService.getQueryable(ExternalDataset.class);
        if (criteria.getLike() != null && !criteria.getLike().isEmpty()) query.where((builder, root) -> builder.like(root.get("label"), "%" + criteria.getLike() + "%"));
        return query;
    }

    @Override
    public ExternalDataset createOrUpdate(ExternalDataset item) {
        return this.databaseService.createOrUpdate(item,ExternalDataset.class);
    }

    @Override
    public ExternalDataset find(UUID id) {
        return this.databaseService.getQueryable(ExternalDataset.class).where((builder, root) -> builder.equal(root.get("id"),id)).getSingle();
    }

    @Override
    public Long count() {
        return null;
    }
}
